import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { AuthService } from './auth.service';

@Injectable()
export class ErrorService {

  constructor(private router:Router,
              private authService:AuthService) { }

  serverError(err, data, callback) {
    if(err || data.error) {
      this.authService.logout();
      this.router.navigate(['/error']);
    }
    else {
      callback();
    }
  }
}
