const db = require('../db');

module.exports.createMem = function(arcaneId, pageId, value, callback) {
  let sql = "INSERT INTO mem (arcane, page, value) VALUES ('" + arcaneId +
  "', '" + pageId +
  "', '" + value + "')";
  db.query(sql, (err, result) => {
    callback(err);
  });
}

module.exports.deleteMem = function(arcaneId, pageId, callback) {
  let sql = "DELETE FROM mem WHERE arcane = '" + arcaneId + "' AND page = '" + pageId + "'";
  db.query(sql, (err, result) => {
    callback(err);
  });
}

module.exports.deletePage = function(pageId, callback) {
  let sql = "DELETE FROM mem WHERE page = '" + pageId + "'";
  db.query(sql, (err, result) => {
    callback(err);
  });
}

module.exports.getMem = function(arcaneId, pageId, callback) {
  let sql = "SELECT value FROM mem WHERE arcane = " + arcaneId + " AND page = " + pageId + "";
  db.query(sql, (err, rows, field) => {
    if(err){
      callback(err, undefined);
    }
    else if(rows.length > 0) {
      callback(null, rows[0].value);
    }
    else {
      callback(null, 0);
    }
  });
}

module.exports.getArcanesOfPage = function(pageId, callback) {
  let sql = "SELECT * FROM mem WHERE page = " + pageId + "";
  db.query(sql, (err, rows, field) => {
    if(err){
      callback(err, undefined);
    }
    else if(rows.length > 0) {
      let m = new Array();
      for(let r of rows) {
        m.push({arcane: r.arcane, value: r.value});
      }
      callback(null, m);
    }
    else {
      callback(null, undefined);
    }
  });
}

module.exports.updateValue = function(arcaneId, pageId, value, callback) {
  let sql = "UPDATE mem SET value = '" + value + "' WHERE arcane = '" + arcaneId + "' AND page = '" + pageId + "'";
  db.query(sql, (err) => {
    callback(err);
  });
}

module.exports.getPagesWithArcane = function(id, callback) {
  let sql = "SELECT * FROM mem WHERE arcane = " + id + "";
  db.query(sql, (err, rows, fields) => {
    if(err) {
      callback(err, undefined);
    }
    else if(rows.length > 0) {
      let m = {};
      for(let r of rows) {
        m[String(r.page)] = r.value;
      }
      callback(null, m);
    }
    else {
      callback(null, undefined);
    }
  });
}

module.exports.getCommendableMems = function(arcaneIds, pageIds, callback) {
  let sql = "SELECT * FROM mem WHERE arcane IN (" + arcaneIds + ") AND page IN (" + pageIds + ") ORDER BY FIND_IN_SET(arcane, '" + arcaneIds + "')";
  db.query(sql, (err, rows, fields) => {
    if(err) {
      callback(err, undefined);
    }
    else if(rows.length > 0) {
      let m = new Array();
      for(let r of rows) {
        m.push({arcane: r.arcane, page: r.page, value: r.value});
      }
      callback(null, m);
    }
    else {
      callback(null, undefined);
    }
  });
}
