import { Injectable } from '@angular/core';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';

@Injectable()
export class AudioPlayerService {

  private arcane = new BehaviorSubject<any>(undefined);
  currentAudioSrc = this.arcane.asObservable();
  private soundOnly = new BehaviorSubject<string>("");
  currentSoundOnly = this.soundOnly.asObservable();

  constructor() { }

  changeSource(a) {
    this.arcane.next(a);
  }

  changeAudioOnly(f) {
    this.soundOnly.next(f);
  }

}
