import { TestBed, inject } from '@angular/core/testing';

import { SvgService } from './svg.service';
import { MathService } from '../services/math.service';

describe('SvgService', () => {
  let MathServiceStub: Partial<MathService>;
  beforeEach(() => {
    TestBed.configureTestingModule({
      providers: [
        SvgService,
        {provide : MathService, useValue: MathServiceStub}
      ]
    });
  });

  it('should be created', inject([SvgService], (service: SvgService) => {
    expect(service).toBeTruthy();
  }));
});
