const server = require('../server');
const assert = require('chai').assert;

const arcane = require('./models/arcane');
const user = require('./models/user');
const users = require('./routes/users');
const generate = require('./routes/generate');
const page = require('./models/page');
const workspace = require('./models/workspace');
const mem = require('./models/mem');

describe('Server', () => {
  before(() => {
    server.startApp(3000, (err) => {
      assert.isNull(err, err);
    });
  });

  arcane;
  user;
  users;
  generate;
  page;
  workspace;
  mem;

  after(() => {
    server.closeApp();
  });
});
